Index: src/test/bfs_test.cc
===================================================================
--- src/test/bfs_test.cc	(revision 1283)
+++ src/test/bfs_test.cc	(revision 1359)
@@ -3,5 +3,5 @@
  *
  * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
- * (Egervary Combinatorial Optimization Research Group, EGRES).
+ * (Egervary Research Group on Combinatorial Optimization, EGRES).
  *
  * Permission to use, modify and distribute this software is granted
Index: src/test/dfs_test.cc
===================================================================
--- src/test/dfs_test.cc	(revision 1283)
+++ src/test/dfs_test.cc	(revision 1359)
@@ -3,5 +3,5 @@
  *
  * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
- * (Egervary Combinatorial Optimization Research Group, EGRES).
+ * (Egervary Research Group on Combinatorial Optimization, EGRES).
  *
  * Permission to use, modify and distribute this software is granted
Index: src/test/dijkstra_test.cc
===================================================================
--- src/test/dijkstra_test.cc	(revision 1283)
+++ src/test/dijkstra_test.cc	(revision 1359)
@@ -3,5 +3,5 @@
  *
  * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
- * (Egervary Combinatorial Optimization Research Group, EGRES).
+ * (Egervary Research Group on Combinatorial Optimization, EGRES).
  *
  * Permission to use, modify and distribute this software is granted
Index: src/test/error_test.cc
===================================================================
--- src/test/error_test.cc	(revision 1164)
+++ src/test/error_test.cc	(revision 1359)
@@ -3,5 +3,5 @@
  *
  * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
- * (Egervary Combinatorial Optimization Research Group, EGRES).
+ * (Egervary Research Group on Combinatorial Optimization, EGRES).
  *
  * Permission to use, modify and distribute this software is granted
Index: src/test/graph_factory_test.cc
===================================================================
--- src/test/graph_factory_test.cc	(revision 1164)
+++ src/test/graph_factory_test.cc	(revision 1359)
@@ -3,5 +3,5 @@
  *
  * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
- * (Egervary Combinatorial Optimization Research Group, EGRES).
+ * (Egervary Research Group on Combinatorial Optimization, EGRES).
  *
  * Permission to use, modify and distribute this software is granted
Index: src/test/graph_test.h
===================================================================
--- src/test/graph_test.h	(revision 1164)
+++ src/test/graph_test.h	(revision 1359)
@@ -3,5 +3,5 @@
  *
  * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
- * (Egervary Combinatorial Optimization Research Group, EGRES).
+ * (Egervary Research Group on Combinatorial Optimization, EGRES).
  *
  * Permission to use, modify and distribute this software is granted
Index: src/test/graph_utils_test.h
===================================================================
--- src/test/graph_utils_test.h	(revision 1164)
+++ src/test/graph_utils_test.h	(revision 1359)
@@ -3,5 +3,5 @@
  *
  * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
- * (Egervary Combinatorial Optimization Research Group, EGRES).
+ * (Egervary Research Group on Combinatorial Optimization, EGRES).
  *
  * Permission to use, modify and distribute this software is granted
Index: src/test/graph_wrapper_test.cc
===================================================================
--- src/test/graph_wrapper_test.cc	(revision 1164)
+++ src/test/graph_wrapper_test.cc	(revision 1359)
@@ -3,5 +3,5 @@
  *
  * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
- * (Egervary Combinatorial Optimization Research Group, EGRES).
+ * (Egervary Research Group on Combinatorial Optimization, EGRES).
  *
  * Permission to use, modify and distribute this software is granted
Index: src/test/kruskal_test.cc
===================================================================
--- src/test/kruskal_test.cc	(revision 1164)
+++ src/test/kruskal_test.cc	(revision 1359)
@@ -3,5 +3,5 @@
  *
  * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
- * (Egervary Combinatorial Optimization Research Group, EGRES).
+ * (Egervary Research Group on Combinatorial Optimization, EGRES).
  *
  * Permission to use, modify and distribute this software is granted
Index: src/test/map_test.h
===================================================================
--- src/test/map_test.h	(revision 1164)
+++ src/test/map_test.h	(revision 1359)
@@ -3,5 +3,5 @@
  *
  * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
- * (Egervary Combinatorial Optimization Research Group, EGRES).
+ * (Egervary Research Group on Combinatorial Optimization, EGRES).
  *
  * Permission to use, modify and distribute this software is granted
Index: src/test/max_matching_test.cc
===================================================================
--- src/test/max_matching_test.cc	(revision 1164)
+++ src/test/max_matching_test.cc	(revision 1359)
@@ -4,5 +4,5 @@
  *
  * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
- * (Egervary Combinatorial Optimization Research Group, EGRES).
+ * (Egervary Research Group on Combinatorial Optimization, EGRES).
  *
  * Permission to use, modify and distribute this software is granted
Index: src/test/min_cost_flow_test.cc
===================================================================
--- src/test/min_cost_flow_test.cc	(revision 1164)
+++ src/test/min_cost_flow_test.cc	(revision 1359)
@@ -3,5 +3,5 @@
  *
  * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
- * (Egervary Combinatorial Optimization Research Group, EGRES).
+ * (Egervary Research Group on Combinatorial Optimization, EGRES).
  *
  * Permission to use, modify and distribute this software is granted
Index: src/test/path_test.cc
===================================================================
--- src/test/path_test.cc	(revision 1164)
+++ src/test/path_test.cc	(revision 1359)
@@ -3,5 +3,5 @@
  *
  * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
- * (Egervary Combinatorial Optimization Research Group, EGRES).
+ * (Egervary Research Group on Combinatorial Optimization, EGRES).
  *
  * Permission to use, modify and distribute this software is granted
Index: src/test/preflow_test.cc
===================================================================
--- src/test/preflow_test.cc	(revision 1222)
+++ src/test/preflow_test.cc	(revision 1359)
@@ -3,5 +3,5 @@
  *
  * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
- * (Egervary Combinatorial Optimization Research Group, EGRES).
+ * (Egervary Research Group on Combinatorial Optimization, EGRES).
  *
  * Permission to use, modify and distribute this software is granted
Index: src/test/suurballe_test.cc
===================================================================
--- src/test/suurballe_test.cc	(revision 1164)
+++ src/test/suurballe_test.cc	(revision 1359)
@@ -3,5 +3,5 @@
  *
  * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
- * (Egervary Combinatorial Optimization Research Group, EGRES).
+ * (Egervary Research Group on Combinatorial Optimization, EGRES).
  *
  * Permission to use, modify and distribute this software is granted
Index: src/test/sym_graph_test.cc
===================================================================
--- src/test/sym_graph_test.cc	(revision 1164)
+++ src/test/sym_graph_test.cc	(revision 1359)
@@ -3,5 +3,5 @@
  *
  * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
- * (Egervary Combinatorial Optimization Research Group, EGRES).
+ * (Egervary Research Group on Combinatorial Optimization, EGRES).
  *
  * Permission to use, modify and distribute this software is granted
Index: src/test/sym_graph_test.h
===================================================================
--- src/test/sym_graph_test.h	(revision 1164)
+++ src/test/sym_graph_test.h	(revision 1359)
@@ -3,5 +3,5 @@
  *
  * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
- * (Egervary Combinatorial Optimization Research Group, EGRES).
+ * (Egervary Research Group on Combinatorial Optimization, EGRES).
  *
  * Permission to use, modify and distribute this software is granted
Index: src/test/test_tools.h
===================================================================
--- src/test/test_tools.h	(revision 1200)
+++ src/test/test_tools.h	(revision 1359)
@@ -3,5 +3,5 @@
  *
  * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
- * (Egervary Combinatorial Optimization Research Group, EGRES).
+ * (Egervary Research Group on Combinatorial Optimization, EGRES).
  *
  * Permission to use, modify and distribute this software is granted
Index: src/test/test_tools_fail.cc
===================================================================
--- src/test/test_tools_fail.cc	(revision 1164)
+++ src/test/test_tools_fail.cc	(revision 1359)
@@ -3,5 +3,5 @@
  *
  * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
- * (Egervary Combinatorial Optimization Research Group, EGRES).
+ * (Egervary Research Group on Combinatorial Optimization, EGRES).
  *
  * Permission to use, modify and distribute this software is granted
Index: src/test/test_tools_pass.cc
===================================================================
--- src/test/test_tools_pass.cc	(revision 1164)
+++ src/test/test_tools_pass.cc	(revision 1359)
@@ -3,5 +3,5 @@
  *
  * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
- * (Egervary Combinatorial Optimization Research Group, EGRES).
+ * (Egervary Research Group on Combinatorial Optimization, EGRES).
  *
  * Permission to use, modify and distribute this software is granted
Index: src/test/time_measure_test.cc
===================================================================
--- src/test/time_measure_test.cc	(revision 1164)
+++ src/test/time_measure_test.cc	(revision 1359)
@@ -3,5 +3,5 @@
  *
  * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
- * (Egervary Combinatorial Optimization Research Group, EGRES).
+ * (Egervary Research Group on Combinatorial Optimization, EGRES).
  *
  * Permission to use, modify and distribute this software is granted
Index: src/test/unionfind_test.cc
===================================================================
--- src/test/unionfind_test.cc	(revision 1164)
+++ src/test/unionfind_test.cc	(revision 1359)
@@ -3,5 +3,5 @@
  *
  * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
- * (Egervary Combinatorial Optimization Research Group, EGRES).
+ * (Egervary Research Group on Combinatorial Optimization, EGRES).
  *
  * Permission to use, modify and distribute this software is granted
Index: src/test/xy_test.cc
===================================================================
--- src/test/xy_test.cc	(revision 1164)
+++ src/test/xy_test.cc	(revision 1359)
@@ -3,5 +3,5 @@
  *
  * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
- * (Egervary Combinatorial Optimization Research Group, EGRES).
+ * (Egervary Research Group on Combinatorial Optimization, EGRES).
  *
  * Permission to use, modify and distribute this software is granted