Index: gui/graph_displayer_canvas-event.cc
===================================================================
--- gui/graph_displayer_canvas-event.cc	(revision 1943)
+++ gui/graph_displayer_canvas-event.cc	(revision 2063)
@@ -332,5 +332,5 @@
       }
       // increment the id map's default value
-      (mytab.mapstorage).nodemap_default["id"] += 1.0;
+      (mytab.mapstorage).nodemap_default["label"] += 1.0;
 
       nodesmap[active_node]=new Gnome::Canvas::Ellipse(displayed_graph,
@@ -442,5 +442,5 @@
               }
               // increment the id map's default value
-              (mytab.mapstorage).edgemap_default["id"] += 1.0;
+              (mytab.mapstorage).edgemap_default["label"] += 1.0;
 
               //calculating coordinates of new edge
@@ -674,5 +674,5 @@
           {
             // the id map is not editable
-            if (edgemap_to_edit == "id") return 0;
+            if (edgemap_to_edit == "label") return 0;
 
             //and there is activated map
@@ -762,5 +762,5 @@
           {
             // the id map is not editable
-            if (nodemap_to_edit == "id") return 0;
+            if (nodemap_to_edit == "label") return 0;
 
             //and there is activated map
Index: gui/gui_reader.cc
===================================================================
--- gui/gui_reader.cc	(revision 1860)
+++ gui/gui_reader.cc	(revision 2063)
@@ -23,5 +23,5 @@
   for (EdgeIt e(mapstorage->graph); e != INVALID; ++e)
   {
-    int edgeid = (int)(*mapstorage->edgemap_storage["id"])[e];
+    int edgeid = (int)(*mapstorage->edgemap_storage["label"])[e];
     mapstorage->arrow_pos.set(e, m[edgeid]);
   }
Index: gui/gui_writer.cc
===================================================================
--- gui/gui_writer.cc	(revision 1860)
+++ gui/gui_writer.cc	(revision 2063)
@@ -16,5 +16,5 @@
   for (EdgeIt e(mapstorage->graph); e != INVALID; ++e)
   {
-    int edgeid = (int)(*(mapstorage->edgemap_storage["id"]))[e];
+    int edgeid = (int)(*(mapstorage->edgemap_storage["label"]))[e];
     m[edgeid] = mapstorage->arrow_pos[e];
   }
Index: gui/mapstorage.cc
===================================================================
--- gui/mapstorage.cc	(revision 1939)
+++ gui/mapstorage.cc	(revision 2063)
@@ -18,9 +18,9 @@
   arrow_pos.setYMap(*edgemap_storage["arrow_pos_y"]);
 
-  nodemap_storage["id"] = new Graph::NodeMap<double>(graph);
-  edgemap_storage["id"] = new Graph::EdgeMap<double>(graph);
-
-  nodemap_default["id"] = 1.0;
-  edgemap_default["id"] = 1.0;
+  nodemap_storage["label"] = new Graph::NodeMap<double>(graph);
+  edgemap_storage["label"] = new Graph::EdgeMap<double>(graph);
+
+  nodemap_default["label"] = 1.0;
+  edgemap_default["label"] = 1.0;
 
   active_nodemaps.resize(NODE_PROPERTY_NUM);
@@ -252,5 +252,5 @@
         //std::cout << "read Y nodemap" << std::endl;
       }
-      else if (*it == "id")
+      else if (*it == "label")
       {
         //std::cout << "read id nodemap" << std::endl;
@@ -266,5 +266,5 @@
         it != edgeMapNames.end(); ++it)
     {
-      if (*it == "id")
+      if (*it == "label")
       {
         //std::cout << "read id edgemap" << std::endl;
@@ -288,9 +288,9 @@
   if (!read_edge_id)
   {
-    edgemap_storage["id"] = new Graph::EdgeMap<double>(graph);
+    edgemap_storage["label"] = new Graph::EdgeMap<double>(graph);
     int i = 1;
     for (EdgeIt e(graph); e != INVALID; ++e)
     {
-      (*edgemap_storage["id"])[e] = i++;
+      (*edgemap_storage["label"])[e] = i++;
     }
   }
@@ -327,5 +327,5 @@
       nodemap_storage.begin(); it != nodemap_storage.end(); ++it)
   {
-    if ((it->first != "id") &&
+    if ((it->first != "label") &&
         (it->first != "coordiantes_x") &&
         (it->first != "coordinates_y"))
@@ -333,14 +333,14 @@
       nodemap_default[it->first] = 0.0;
     }
-    else if (it->first == "id")
+    else if (it->first == "label")
     {
       NodeIt n(graph);
-      double max = (*nodemap_storage["id"])[n];
+      double max = (*nodemap_storage["label"])[n];
       for (; n != INVALID; ++n)
       {
-        if ((*nodemap_storage["id"])[n] > max)
-          max = (*nodemap_storage["id"])[n];
-      }
-      nodemap_default["id"] = max + 1.0;
+        if ((*nodemap_storage["label"])[n] > max)
+          max = (*nodemap_storage["label"])[n];
+      }
+      nodemap_default["label"] = max + 1.0;
     }
   }
@@ -348,5 +348,5 @@
       edgemap_storage.begin(); it != edgemap_storage.end(); ++it)
   {
-    if (it->first != "id")
+    if (it->first != "label")
     {
       edgemap_default[it->first] = 0.0;
@@ -357,11 +357,11 @@
       for (EdgeIt e(graph); e != INVALID; ++e)
       {
-        if ((*edgemap_storage["id"])[e] > max)
-          max = (*edgemap_storage["id"])[e];
+        if ((*edgemap_storage["label"])[e] > max)
+          max = (*edgemap_storage["label"])[e];
       }
       if (max > std::numeric_limits<double>::min())
-        edgemap_default["id"] = max + 1.0;
+        edgemap_default["label"] = max + 1.0;
       else
-        edgemap_default["id"] = 1.0;
+        edgemap_default["label"] = 1.0;
     }
   }
@@ -401,5 +401,5 @@
     if ((it->first != "coordinates_x") &&
         (it->first != "coordinates_y") &&
-        (it->first != "id"))
+        (it->first != "label"))
     {
       delete it->second;
@@ -410,5 +410,5 @@
       edgemap_storage.begin(); it != edgemap_storage.end(); ++it)
   {
-    if ((it->first != "id") &&
+    if ((it->first != "label") &&
         (it->first != "arrow_pos_x") &&
         (it->first != "arrow_pos_y"))
@@ -421,5 +421,5 @@
       nodemap_default.begin(); it != nodemap_default.end(); ++it)
   {
-    if (it->first != "id")
+    if (it->first != "label")
       nodemap_default.erase(it);
   }
@@ -427,5 +427,5 @@
       edgemap_default.begin(); it != edgemap_default.end(); ++it)
   {
-    if (it->first != "id")
+    if (it->first != "label")
       edgemap_default.erase(it);
   }